<script setup lang="ts">
  import { ClientApiError } from '@shopware-pwa/types';
  import { getErrorMessages } from '~/helpers/errors';

  const promoteCode = ref<string>('');

  const { t } = useI18n();
  const { createToast } = useToasts();
  const { addPromotionCode } = useCart();

  const onSubmitPromoteCode = async (e: Event) => {
    e.preventDefault();

    try {
      const res = await addPromotionCode(promoteCode.value);

      if (res.errors['promotion-not-found']) {
        createToast({ content: t(res.errors['promotion-not-found'].message), variant: 'error' });
      } else {
        createToast({
          content: t('form.messages.applyPromoteCodeSuccess'),
          variant: 'success',
        });
      }

      promoteCode.value = '';
    } catch (error) {
      const message = getErrorMessages(error as ClientApiError) as string;
      createToast({ content: message, variant: 'error' });
    }
  };
</script>

<template>
  <div class="flex justify-between space-x-3 border-b pb-4 pt-3">
    <SwTextField
      id="promote"
      v-model="promoteCode"
      :placeholder="$t('form.promoCodePlaceholder')"
      name="promote"
      type="text"
      class="flex-1"
    />

    <SwButton variant="action" :disabled="!promoteCode" @click="onSubmitPromoteCode">
      {{ $t('apply') }}
    </SwButton>
  </div>
</template>
